import java.util.*;
import javax.persistence.*;

/*
 Possible issue for default id generator when strategy is sequence
 Error: Incomplete definition of auto value in field 
 MyTestCase$MyEntity.idgenerator name is missing (error 342)

 See lines 35 and 36: in my opinion there is no default generator
 but the element generator is optional in the doc.
*/ 
public final class MyTestCase {
 
    public static void main(String[] args)  {
        EntityManagerFactory emf =
            Persistence.createEntityManagerFactory(
                "objectdb:$objectdb/db/test.tmp;drop");
        EntityManager em = emf.createEntityManager();
 
        em.getTransaction().begin();
        MyEntity e = new MyEntity("test");
        em.persist(e);
        em.getTransaction().commit();
 
        Query query = em.createQuery("SELECT e FROM MyEntity e");
        List resultList = query.getResultList();
        System.out.println(resultList);
 
        em.close();
        emf.close();
    }
 
    @Entity
    public static class MyEntity {
        @GeneratedValue(strategy=GenerationType.SEQUENCE)//, generator="seq") 
        @Id  @SequenceGenerator(name="seq") //workaround uncomment previous line
        private long id;
        private String name;

        MyEntity(String name) {
            this.name = name;
        }
        public long getId() {
            return id;
        }
        public void setId(long id) {
            this.id = id;
        }
        public String getName() {
            return name;
        }
        public void setName(String name) {
            this.name = name;
        }
        @Override
        public String toString() {
            return name;
        }
    }
}

